"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var getFileSystemEntry_exports = {};
__export(getFileSystemEntry_exports, {
  getFileSystemEntry: () => getFileSystemEntry
});
module.exports = __toCommonJS(getFileSystemEntry_exports);
var import_fs = __toESM(require("fs"));
var import_path = __toESM(require("path"));
var import_utils = require("@modern-js/utils");
var import_isDefaultExportFunction = require("./isDefaultExportFunction");
var import_constants = require("./constants");
const hasIndex = (dir) => (0, import_utils.findExists)(import_constants.JS_EXTENSIONS.map((ext) => import_path.default.resolve(dir, `${import_constants.INDEX_FILE_NAME}${ext}`)));
const hasApp = (dir) => (0, import_utils.findExists)(import_constants.JS_EXTENSIONS.map((ext) => import_path.default.resolve(dir, `${import_constants.APP_FILE_NAME}${ext}`)));
const hasPages = (dir) => import_fs.default.existsSync(import_path.default.join(dir, import_constants.PAGES_DIR_NAME));
const hasNestedRoutes = (dir) => import_fs.default.existsSync(import_path.default.join(dir, import_constants.NESTED_ROUTES_DIR));
const isBundleEntry = (dir) => hasApp(dir) || hasPages(dir) || hasIndex(dir) || hasNestedRoutes(dir);
const scanDir = (dirs) => dirs.map((dir) => {
  const indexFile = hasIndex(dir);
  const customBootstrap = (0, import_isDefaultExportFunction.isDefaultExportFunction)(indexFile) ? indexFile : false;
  const entryName = import_path.default.basename(dir);
  if (indexFile && !customBootstrap) {
    return {
      entryName,
      isMainEntry: false,
      entry: indexFile,
      absoluteEntryDir: import_path.default.resolve(dir),
      isAutoMount: false
    };
  }
  const isHasApp = hasApp(dir);
  if (isHasApp) {
    return {
      entryName,
      isMainEntry: false,
      entry: import_path.default.join(dir, import_constants.APP_FILE_NAME),
      isAutoMount: true,
      absoluteEntryDir: import_path.default.resolve(dir),
      customBootstrap
    };
  }
  const isHasNestedRoutes = hasNestedRoutes(dir);
  const isHasPages = hasPages(dir);
  if (isHasNestedRoutes || isHasPages) {
    const entrypoint = {
      entryName,
      isMainEntry: false,
      entry: "",
      fileSystemRoutes: {
        globalApp: (0, import_utils.findExists)(import_constants.JS_EXTENSIONS.map((ext) => import_path.default.resolve(dir, `./${import_constants.PAGES_DIR_NAME}/${import_constants.FILE_SYSTEM_ROUTES_GLOBAL_LAYOUT}${ext}`)))
      },
      isAutoMount: true,
      absoluteEntryDir: import_path.default.resolve(dir),
      customBootstrap
    };
    if (isHasPages) {
      entrypoint.entry = import_path.default.join(dir, import_constants.PAGES_DIR_NAME);
      entrypoint.pageRoutesEntry = entrypoint.entry;
    }
    if (isHasNestedRoutes) {
      entrypoint.entry = import_path.default.join(dir, import_constants.NESTED_ROUTES_DIR);
      entrypoint.nestedRoutesEntry = entrypoint.entry;
    }
    return entrypoint;
  }
  return {
    entryName,
    isMainEntry: false,
    entry: indexFile,
    absoluteEntryDir: import_path.default.resolve(dir),
    isAutoMount: false
  };
});
const getFileSystemEntry = (appContext, config) => {
  const { appDirectory } = appContext;
  const { source: { entriesDir, disableEntryDirs } } = config;
  let disabledDirs = [];
  if (disableEntryDirs && Array.isArray(disableEntryDirs)) {
    disabledDirs = disableEntryDirs === null || disableEntryDirs === void 0 ? void 0 : disableEntryDirs.map((dir) => (0, import_utils.ensureAbsolutePath)(appDirectory, dir));
  }
  const src = (0, import_utils.ensureAbsolutePath)(appDirectory, entriesDir || "");
  if (import_fs.default.existsSync(src)) {
    if (import_fs.default.statSync(src).isDirectory()) {
      return scanDir(isBundleEntry(src) ? [
        src
      ] : import_fs.default.readdirSync(src).map((file) => import_path.default.join(src, file)).filter((file) => import_fs.default.statSync(file).isDirectory() && isBundleEntry(file) && !disabledDirs.includes(file)));
    } else {
      throw Error(`source.entriesDir accept a directory.`);
    }
  } else {
    throw Error(`src dir ${entriesDir} not found.`);
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  getFileSystemEntry
});
