"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var builder_webpack_exports = {};
__export(builder_webpack_exports, {
  createWebpackBuilderForModern: () => createWebpackBuilderForModern
});
module.exports = __toCommonJS(builder_webpack_exports);
var import_generator = require("../generator");
var import_adapterModern = require("./adapterModern");
async function createWebpackBuilderForModern(options) {
  const builder = await (0, import_generator.generateBuilder)(options, "webpack");
  const { normalizedConfig } = options;
  if (normalizedConfig.tools.esbuild) {
    const { esbuild: esbuildOptions } = normalizedConfig.tools;
    const { pluginEsbuild } = await Promise.resolve().then(() => __toESM(require("@modern-js/rsbuild-plugin-esbuild")));
    builder.addPlugins([
      pluginEsbuild(esbuildOptions)
    ]);
  }
  builder.addPlugins([
    (0, import_adapterModern.builderPluginAdapterModern)(options)
  ]);
  return builder;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  createWebpackBuilderForModern
});
