"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var generator_exports = {};
__export(generator_exports, {
  generateBuilder: () => generateBuilder
});
module.exports = __toCommonJS(generator_exports);
var import_uni_builder = require("@modern-js/uni-builder");
var import_createBuilderProviderConfig = require("./createBuilderProviderConfig");
var import_getBuilderTargets = require("./getBuilderTargets");
var import_createBuilderOptions = require("./createBuilderOptions");
async function generateBuilder(options, bundlerType) {
  const { normalizedConfig, appContext } = options;
  const builderConfig = (0, import_createBuilderProviderConfig.createBuilderProviderConfig)(normalizedConfig, appContext);
  const target = (0, import_getBuilderTargets.getBuilderTargets)(normalizedConfig);
  const builderOptions = (0, import_createBuilderOptions.createBuilderOptions)(target, appContext);
  const builder = await (0, import_uni_builder.createUniBuilder)({
    ...builderOptions,
    bundlerType,
    config: builderConfig
  });
  await applyBuilderPlugins(builder, options);
  return builder;
}
async function applyBuilderPlugins(builder, options) {
  const { builderPluginAdapterBasic, builderPluginAdapterHtml, builderPluginAdapterSSR, builderPluginAdapterWorker } = await Promise.resolve().then(() => __toESM(require("../shared/builderPlugins")));
  builder.addPlugins([
    builderPluginAdapterBasic(),
    builderPluginAdapterSSR(options),
    builderPluginAdapterHtml(options),
    builderPluginAdapterWorker()
  ]);
  const { normalizedConfig } = options;
  if (!normalizedConfig.output.disableNodePolyfill) {
    const { pluginNodePolyfill } = await Promise.resolve().then(() => __toESM(require("@rsbuild/plugin-node-polyfill")));
    builder.addPlugins([
      pluginNodePolyfill()
    ]);
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  generateBuilder
});
