"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var adapterWorker_exports = {};
__export(adapterWorker_exports, {
  builderPluginAdapterWorker: () => builderPluginAdapterWorker
});
module.exports = __toCommonJS(adapterWorker_exports);
var import_path = require("path");
const getDistPath = (outputConfig, type) => {
  const { distPath } = outputConfig;
  const ret = distPath[type];
  if (typeof ret !== "string") {
    throw new Error(`unknown key ${type} in "output.distPath"`);
  }
  return ret;
};
const builderPluginAdapterWorker = () => ({
  name: "builder-plugin-adapter-worker",
  setup(api) {
    api.modifyBundlerChain(async (chain, { isServiceWorker }) => {
      const config = api.getNormalizedConfig();
      if (isServiceWorker) {
        const workerPath = getDistPath(config.output, "worker");
        const filename = import_path.posix.join(workerPath, `[name].js`);
        chain.output.filename(filename).chunkFilename(filename).libraryTarget("commonjs2");
      }
    });
  }
});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  builderPluginAdapterWorker
});
