"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var dev_exports = {};
__export(dev_exports, {
  dev: () => dev
});
module.exports = __toCommonJS(dev_exports);
var import_core = require("@modern-js/core");
var import_utils = require("@modern-js/utils");
var import_server = require("@modern-js/server");
var import_prod_server = require("@modern-js/prod-server");
var import_register = require("../utils/register");
var import_printInstructions = require("../utils/printInstructions");
var import_createServer = require("../utils/createServer");
var import_routes = require("../utils/routes");
var import_config = require("../utils/config");
var import_getServerInternalPlugins = require("../utils/getServerInternalPlugins");
const dev = async (api, options, devServerOptions = {}) => {
  var _normalizedConfig_source, _normalizedConfig_tools;
  if (options.analyze) {
    process.env.BUNDLE_ANALYZE = "true";
  }
  let normalizedConfig = api.useResolvedConfigContext();
  const appContext = api.useAppContext();
  const hookRunners = api.useHookRunners();
  await (0, import_register.registerCompiler)(appContext.appDirectory, appContext.distDirectory, normalizedConfig === null || normalizedConfig === void 0 ? void 0 : (_normalizedConfig_source = normalizedConfig.source) === null || _normalizedConfig_source === void 0 ? void 0 : _normalizedConfig_source.alias);
  normalizedConfig = {
    ...normalizedConfig,
    cliOptions: options
  };
  import_core.ResolvedConfigContext.set(normalizedConfig);
  const { appDirectory, distDirectory, port, apiOnly, serverConfigFile, metaName, serverRoutes } = appContext;
  await (0, import_config.buildServerConfig)({
    appDirectory,
    distDirectory,
    configFile: serverConfigFile,
    watch: true
  });
  await hookRunners.beforeDev();
  if (!appContext.builder && !apiOnly) {
    throw new Error("Expect the Builder to have been initialized, But the appContext.builder received `undefined`");
  }
  await (0, import_routes.generateRoutes)(appContext);
  const serverInternalPlugins = await (0, import_getServerInternalPlugins.getServerInternalPlugins)(api);
  const serverOptions = {
    metaName,
    dev: {
      port,
      https: normalizedConfig.dev.https,
      host: normalizedConfig.dev.host,
      ...(_normalizedConfig_tools = normalizedConfig.tools) === null || _normalizedConfig_tools === void 0 ? void 0 : _normalizedConfig_tools.devServer
    },
    appContext: {
      appDirectory,
      apiDirectory: appContext.apiDirectory,
      lambdaDirectory: appContext.lambdaDirectory,
      sharedDirectory: appContext.sharedDirectory
    },
    routes: serverRoutes,
    pwd: appDirectory,
    config: normalizedConfig,
    serverConfigFile,
    internalPlugins: serverInternalPlugins,
    ...devServerOptions
  };
  if (apiOnly) {
    var _normalizedConfig_dev;
    const app = await (0, import_server.createDevServer)(serverOptions, import_prod_server.initProdMiddlewares);
    const host = ((_normalizedConfig_dev = normalizedConfig.dev) === null || _normalizedConfig_dev === void 0 ? void 0 : _normalizedConfig_dev.host) || import_utils.DEFAULT_DEV_HOST;
    app.listen({
      port,
      host
    }, () => {
      (0, import_printInstructions.printInstructions)(hookRunners, appContext, normalizedConfig);
    });
  } else {
    const { server } = await appContext.builder.startDevServer({
      serverOptions,
      initProdMiddlewares: import_prod_server.initProdMiddlewares
    });
    (0, import_createServer.setServer)(server);
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  dev
});
