"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var deploy_exports = {};
__export(deploy_exports, {
  default: () => deploy_default
});
module.exports = __toCommonJS(deploy_exports);
var import_path = __toESM(require("path"));
var import_utils = require("@modern-js/utils");
var import_utils2 = require("./utils");
var import_dependencies = require("./dependencies");
var deploy_default = () => ({
  name: "@modern-js/plugin-deploy",
  pre: [
    "@modern-js/plugin-bff",
    "@modern-js/plugin-server"
  ],
  setup: (api) => {
    return {
      async beforeDeploy() {
        const appContext = api.useAppContext();
        const { appDirectory, distDirectory, serverInternalPlugins, sharedDirectory, apiDirectory, lambdaDirectory, metaName } = appContext;
        const configContext = api.useResolvedConfigContext();
        const outputDirectory = import_path.default.join(appDirectory, ".output");
        await import_utils.fs.remove(outputDirectory);
        await import_utils.fs.copy(distDirectory, outputDirectory, {
          filter: (src) => {
            const distStaticDirectory = import_path.default.join(distDirectory, "static");
            return !src.includes(distStaticDirectory);
          }
        });
        const { bff } = configContext;
        const config = {
          output: {
            path: "."
          },
          bff
        };
        const plugins = (0, import_utils.getInternalPlugins)(appDirectory, serverInternalPlugins);
        const serverAppContext = {
          sharedDirectory: `path.join(__dirname, "${import_path.default.relative(appDirectory, sharedDirectory)}")`,
          apiDirectory: `path.join(__dirname, "${import_path.default.relative(appDirectory, apiDirectory)}")`,
          lambdaDirectory: `path.join(__dirname, "${import_path.default.relative(appDirectory, lambdaDirectory)}")`,
          metaName
        };
        let code = ``;
        const deployTarget = process.env.MODERNJS_DEPLOY || "node";
        console.log("deployTarget111111111", deployTarget);
        switch (deployTarget) {
          case "node": {
            const { genNodeEntry } = await Promise.resolve().then(() => __toESM(require("./entrys/node")));
            code = genNodeEntry({
              plugins,
              config,
              appContext: serverAppContext
            });
            break;
          }
          case "netlify": {
            const { genNetlifyEntry } = await Promise.resolve().then(() => __toESM(require("./entrys/netlify")));
            code = genNetlifyEntry({
              plugins,
              config,
              appContext: serverAppContext
            });
            break;
          }
          default: {
            code = `throw new Error("unknown deploy target, MODERNJS_DEPLOY should be set");`;
          }
        }
        const { useSSR, useAPI, useWebServer } = (0, import_utils2.getProjectUsage)(appDirectory, outputDirectory);
        const entryFilePath = import_path.default.join(outputDirectory, "index.js");
        if (useSSR || useAPI || useWebServer) {
          await import_utils.fs.writeFile(entryFilePath, code);
        }
        await (0, import_dependencies.handleDependencies)(appDirectory, outputDirectory, [
          "@modern-js/prod-server"
        ]);
      }
    };
  }
});
