const JS_EXTENSIONS = [
  ".js",
  ".ts",
  ".jsx",
  ".tsx"
];
const INDEX_FILE_NAME = "index";
const APP_FILE_NAME = "App";
const PAGES_DIR_NAME = "pages";
const NESTED_ROUTES_DIR = "routes";
const FILE_SYSTEM_ROUTES_FILE_NAME = "routes.js";
const LOADER_EXPORT_NAME = "loader";
const ACTION_EXPORT_NAME = "action";
const TEMP_LOADERS_DIR = "__loaders__";
const ENTRY_POINT_FILE_NAME = "index.jsx";
const ENTRY_BOOTSTRAP_FILE_NAME = "bootstrap.jsx";
const FILE_SYSTEM_ROUTES_DYNAMIC_REGEXP = /^\[(\S+)\]([*+?]?)$/;
const FILE_SYSTEM_ROUTES_LAYOUT = "_layout";
const FILE_SYSTEM_ROUTES_GLOBAL_LAYOUT = "_app";
const FILE_SYSTEM_ROUTES_INDEX = "index";
const FILE_SYSTEM_ROUTES_IGNORED_REGEX = /\.(d|test|spec|e2e)\.(js|jsx|ts|tsx)$/;
const HTML_PARTIALS_FOLDER = "html";
const HTML_PARTIALS_EXTENSIONS = [
  ".htm",
  ".html",
  ".ejs"
];
const FILE_SYSTEM_ROUTES_COMPONENTS_DIR = "internal_components";
const NESTED_ROUTE = {
  LAYOUT_FILE: "layout",
  LAYOUT_CONFIG_FILE: "layout.config",
  LAYOUT_LOADER_FILE: "layout.loader",
  LAYOUT_DATA_FILE: "layout.data",
  LAYOUT_CLIENT_LOADER: "layout.data.client",
  PAGE_FILE: "page",
  PAGE_CONFIG_FILE: "page.config",
  PAGE_LOADER_FILE: "page.loader",
  PAGE_DATA_FILE: "page.data",
  PAGE_CLIENT_LOADER: "page.data.client",
  SPLATE_FILE: "$",
  SPLATE_CONFIG_FILE: "$.config",
  SPLATE_LOADER_FILE: "$.loader",
  SPLATE_DATA_FILE: "$.data",
  SPLATE_CLIENT_DATA: "$.data.client",
  LOADING_FILE: "loading",
  ERROR_FILE: "error",
  LOADER_FILE: "loader"
};
const APP_CONFIG_NAME = "config";
const APP_INIT_EXPORTED = "init";
const APP_INIT_IMPORTED = "appInit";
export {
  ACTION_EXPORT_NAME,
  APP_CONFIG_NAME,
  APP_FILE_NAME,
  APP_INIT_EXPORTED,
  APP_INIT_IMPORTED,
  ENTRY_BOOTSTRAP_FILE_NAME,
  ENTRY_POINT_FILE_NAME,
  FILE_SYSTEM_ROUTES_COMPONENTS_DIR,
  FILE_SYSTEM_ROUTES_DYNAMIC_REGEXP,
  FILE_SYSTEM_ROUTES_FILE_NAME,
  FILE_SYSTEM_ROUTES_GLOBAL_LAYOUT,
  FILE_SYSTEM_ROUTES_IGNORED_REGEX,
  FILE_SYSTEM_ROUTES_INDEX,
  FILE_SYSTEM_ROUTES_LAYOUT,
  HTML_PARTIALS_EXTENSIONS,
  HTML_PARTIALS_FOLDER,
  INDEX_FILE_NAME,
  JS_EXTENSIONS,
  LOADER_EXPORT_NAME,
  NESTED_ROUTE,
  NESTED_ROUTES_DIR,
  PAGES_DIR_NAME,
  TEMP_LOADERS_DIR
};
