function createBuilderOptions(target, appContext) {
  const entries = {};
  const { entrypoints = [], checkedEntries } = appContext;
  for (const { entryName, internalEntry, entry } of entrypoints) {
    if (checkedEntries && !checkedEntries.includes(entryName)) {
      continue;
    }
    const finalEntry = internalEntry || entry;
    if (entryName in entries) {
      entries[entryName].push(finalEntry);
    } else {
      entries[entryName] = [
        finalEntry
      ];
    }
  }
  return {
    cwd: appContext.appDirectory,
    target,
    frameworkConfigPath: appContext.configFile || void 0,
    entry: entries
  };
}
export {
  createBuilderOptions
};
