import { isProd, isServiceWorker, isSSR, isUseSSRBundle } from "@modern-js/utils";
function getBuilderTargets(normalizedConfig) {
  const targets = [
    "web"
  ];
  const useNodeTarget = isProd() ? isUseSSRBundle(normalizedConfig) : isSSR(normalizedConfig);
  if (useNodeTarget) {
    targets.push("node");
  }
  const useWorkerTarget = isServiceWorker(normalizedConfig);
  if (useWorkerTarget) {
    targets.push("service-worker");
  }
  return targets;
}
export {
  getBuilderTargets
};
