import { join } from "path";
const inspect = async (api, options) => {
  const appContext = api.useAppContext();
  if (!appContext.builder) {
    throw new Error("Expect the Builder to have been initialized, But the appContext.builder received `undefined`");
  }
  return appContext.builder.inspectConfig({
    env: options.env,
    verbose: options.verbose,
    outputPath: join(appContext === null || appContext === void 0 ? void 0 : appContext.builder.context.distPath, options.output),
    writeToDisk: true
  });
};
export {
  inspect
};
