import { createToolsConfig } from "./createToolsConfig";
import { createSourceConfig } from "./createSourceConfig";
import { createOutputConfig } from "./createOutputConfig";
import { createHtmlConfig } from "./createHtmlConfig";
function transformNormalizedConfig(config) {
  const html = createHtmlConfig(config);
  const output = createOutputConfig(config);
  const source = createSourceConfig(config);
  const tools = createToolsConfig(config);
  const { bff, dev, deploy, runtime, runtimeByEntries, server, cliOptions, plugins, testing, autoLoadPlugins } = config;
  return {
    source,
    html,
    output,
    tools,
    bff,
    dev,
    deploy,
    runtime,
    runtimeByEntries,
    server,
    cliOptions,
    testing,
    devtools: {},
    builderPlugins: [],
    plugins,
    security: {},
    _raw: {},
    experiments: {},
    autoLoadPlugins,
    performance: {
      removeMomentLocale: true
    }
  };
}
function checkIsLegacyConfig(config) {
  return Boolean(config.legacy);
}
export {
  checkIsLegacyConfig,
  transformNormalizedConfig
};
