import { createDevServer } from "@modern-js/server";
import { initProdMiddlewares } from "@modern-js/prod-server";
let server = null;
const getServer = () => server;
const setServer = (newServer) => {
  server = newServer;
};
const closeServer = async () => {
  if (server) {
    server.close();
    server = null;
  }
};
const createServer = async (options) => {
  if (server) {
    server.close();
  }
  server = await createDevServer(options, initProdMiddlewares);
  return server;
};
export {
  closeServer,
  createServer,
  getServer,
  setServer
};
