import { cli } from "@modern-js/core";
import { chalk, clearConsole, getFullArgv, logger, program } from "@modern-js/utils";
async function restart(hooksRunner, filename) {
  clearConsole();
  logger.info(`Restart because ${chalk.yellow(filename)} is changed...
`);
  let hasGetError = false;
  await hooksRunner.beforeRestart();
  try {
    await cli.init(cli.getPrevInitOptions());
  } catch (err) {
    console.error(err);
    hasGetError = true;
  } finally {
    if (!hasGetError) {
      program.parse(getFullArgv());
    }
  }
}
export {
  restart
};
