import { isProd, isServiceWorker, isSSR, isUseSSRBundle } from "@modern-js/utils";
function getBuilderTargets(normalizedConfig) {
  var targets = [
    "web"
  ];
  var useNodeTarget = isProd() ? isUseSSRBundle(normalizedConfig) : isSSR(normalizedConfig);
  if (useNodeTarget) {
    targets.push("node");
  }
  var useWorkerTarget = isServiceWorker(normalizedConfig);
  if (useWorkerTarget) {
    targets.push("service-worker");
  }
  return targets;
}
export {
  getBuilderTargets
};
