import { _ as _async_to_generator } from "@swc/helpers/_/_async_to_generator";
import { _ as _object_spread } from "@swc/helpers/_/_object_spread";
import { _ as _object_spread_props } from "@swc/helpers/_/_object_spread_props";
import { _ as _ts_generator } from "@swc/helpers/_/_ts_generator";
import { createUniBuilder } from "@modern-js/uni-builder";
import { createBuilderProviderConfig } from "./createBuilderProviderConfig";
import { getBuilderTargets } from "./getBuilderTargets";
import { createBuilderOptions } from "./createBuilderOptions";
function generateBuilder(options, bundlerType) {
  return _generateBuilder.apply(this, arguments);
}
function _generateBuilder() {
  _generateBuilder = _async_to_generator(function(options, bundlerType) {
    var normalizedConfig, appContext, builderConfig, target, builderOptions, builder;
    return _ts_generator(this, function(_state) {
      switch (_state.label) {
        case 0:
          normalizedConfig = options.normalizedConfig, appContext = options.appContext;
          builderConfig = createBuilderProviderConfig(normalizedConfig, appContext);
          target = getBuilderTargets(normalizedConfig);
          builderOptions = createBuilderOptions(target, appContext);
          return [
            4,
            createUniBuilder(_object_spread_props(_object_spread({}, builderOptions), {
              bundlerType,
              config: builderConfig
            }))
          ];
        case 1:
          builder = _state.sent();
          return [
            4,
            applyBuilderPlugins(builder, options)
          ];
        case 2:
          _state.sent();
          return [
            2,
            builder
          ];
      }
    });
  });
  return _generateBuilder.apply(this, arguments);
}
function applyBuilderPlugins(builder, options) {
  return _applyBuilderPlugins.apply(this, arguments);
}
function _applyBuilderPlugins() {
  _applyBuilderPlugins = _async_to_generator(function(builder, options) {
    var _ref, builderPluginAdapterBasic, builderPluginAdapterHtml, builderPluginAdapterSSR, builderPluginAdapterWorker, normalizedConfig, pluginNodePolyfill;
    return _ts_generator(this, function(_state) {
      switch (_state.label) {
        case 0:
          return [
            4,
            import("../shared/builderPlugins")
          ];
        case 1:
          _ref = _state.sent(), builderPluginAdapterBasic = _ref.builderPluginAdapterBasic, builderPluginAdapterHtml = _ref.builderPluginAdapterHtml, builderPluginAdapterSSR = _ref.builderPluginAdapterSSR, builderPluginAdapterWorker = _ref.builderPluginAdapterWorker;
          builder.addPlugins([
            builderPluginAdapterBasic(),
            builderPluginAdapterSSR(options),
            builderPluginAdapterHtml(options),
            builderPluginAdapterWorker()
          ]);
          normalizedConfig = options.normalizedConfig;
          if (!!normalizedConfig.output.disableNodePolyfill)
            return [
              3,
              3
            ];
          return [
            4,
            import("@rsbuild/plugin-node-polyfill")
          ];
        case 2:
          pluginNodePolyfill = _state.sent().pluginNodePolyfill;
          builder.addPlugins([
            pluginNodePolyfill()
          ]);
          _state.label = 3;
        case 3:
          return [
            2
          ];
      }
    });
  });
  return _applyBuilderPlugins.apply(this, arguments);
}
export {
  generateBuilder
};
