import { _ as _async_to_generator } from "@swc/helpers/_/_async_to_generator";
import { _ as _ts_generator } from "@swc/helpers/_/_ts_generator";
import { posix } from "path";
var getDistPath = function(outputConfig, type) {
  var distPath = outputConfig.distPath;
  var ret = distPath[type];
  if (typeof ret !== "string") {
    throw new Error("unknown key ".concat(type, ' in "output.distPath"'));
  }
  return ret;
};
var builderPluginAdapterWorker = function() {
  return {
    name: "builder-plugin-adapter-worker",
    setup: function setup(api) {
      api.modifyBundlerChain(function() {
        var _ref = _async_to_generator(function(chain, param) {
          var isServiceWorker, config, workerPath, filename;
          return _ts_generator(this, function(_state) {
            isServiceWorker = param.isServiceWorker;
            config = api.getNormalizedConfig();
            if (isServiceWorker) {
              workerPath = getDistPath(config.output, "worker");
              filename = posix.join(workerPath, "[name].js");
              chain.output.filename(filename).chunkFilename(filename).libraryTarget("commonjs2");
            }
            return [
              2
            ];
          });
        });
        return function(chain, _) {
          return _ref.apply(this, arguments);
        };
      }());
    }
  };
};
export {
  builderPluginAdapterWorker
};
