import { _ as _async_to_generator } from "@swc/helpers/_/_async_to_generator";
import { _ as _object_spread } from "@swc/helpers/_/_object_spread";
import { _ as _object_spread_props } from "@swc/helpers/_/_object_spread_props";
import { _ as _ts_generator } from "@swc/helpers/_/_ts_generator";
import { ResolvedConfigContext } from "@modern-js/core";
import { logger } from "@modern-js/utils";
import { generateRoutes } from "../utils/routes";
import { buildServerConfig } from "../utils/config";
import { registerCompiler } from "../utils/register";
var build = function() {
  var _ref = _async_to_generator(function(api, options) {
    var _resolvedConfig_source, resolvedConfig, appContext, hookRunners, apiOnly, appDirectory, distDirectory, serverConfigFile, distDirectory1, appDirectory1, serverConfigFile1;
    return _ts_generator(this, function(_state) {
      switch (_state.label) {
        case 0:
          if (options === null || options === void 0 ? void 0 : options.analyze) {
            process.env.BUNDLE_ANALYZE = "true";
          }
          resolvedConfig = api.useResolvedConfigContext();
          appContext = api.useAppContext();
          hookRunners = api.useHookRunners();
          return [
            4,
            registerCompiler(appContext.appDirectory, appContext.distDirectory, resolvedConfig === null || resolvedConfig === void 0 ? void 0 : (_resolvedConfig_source = resolvedConfig.source) === null || _resolvedConfig_source === void 0 ? void 0 : _resolvedConfig_source.alias)
          ];
        case 1:
          _state.sent();
          apiOnly = appContext.apiOnly;
          if (!apiOnly)
            return [
              3,
              6
            ];
          appDirectory = appContext.appDirectory, distDirectory = appContext.distDirectory, serverConfigFile = appContext.serverConfigFile;
          return [
            4,
            hookRunners.beforeBuild({
              // "null" bundlerConfigs
              bundlerConfigs: void 0
            })
          ];
        case 2:
          _state.sent();
          return [
            4,
            buildServerConfig({
              appDirectory,
              distDirectory,
              configFile: serverConfigFile
            })
          ];
        case 3:
          _state.sent();
          return [
            4,
            generateRoutes(appContext)
          ];
        case 4:
          _state.sent();
          return [
            4,
            hookRunners.afterBuild({
              // "null" stats
              stats: void 0
            })
          ];
        case 5:
          _state.sent();
          return [
            2
          ];
        case 6:
          resolvedConfig = _object_spread_props(_object_spread({}, resolvedConfig), {
            cliOptions: options
          });
          ResolvedConfigContext.set(resolvedConfig);
          distDirectory1 = appContext.distDirectory, appDirectory1 = appContext.appDirectory, serverConfigFile1 = appContext.serverConfigFile;
          return [
            4,
            buildServerConfig({
              appDirectory: appDirectory1,
              distDirectory: distDirectory1,
              configFile: serverConfigFile1
            })
          ];
        case 7:
          _state.sent();
          logger.info("Starting production build...");
          if (!appContext.builder) {
            throw new Error("Expect the Builder to have been initialized, But the appContext.builder received `undefined`");
          }
          return [
            4,
            appContext.builder.build()
          ];
        case 8:
          _state.sent();
          return [
            2
          ];
      }
    });
  });
  return function build2(api, options) {
    return _ref.apply(this, arguments);
  };
}();
export {
  build
};
