import { _ as _async_to_generator } from "@swc/helpers/_/_async_to_generator";
import { _ as _object_spread } from "@swc/helpers/_/_object_spread";
import { _ as _object_spread_props } from "@swc/helpers/_/_object_spread_props";
import { _ as _ts_generator } from "@swc/helpers/_/_ts_generator";
import { ResolvedConfigContext } from "@modern-js/core";
import { DEFAULT_DEV_HOST } from "@modern-js/utils";
import { createDevServer } from "@modern-js/server";
import { initProdMiddlewares } from "@modern-js/prod-server";
import { registerCompiler } from "../utils/register";
import { printInstructions } from "../utils/printInstructions";
import { setServer } from "../utils/createServer";
import { generateRoutes } from "../utils/routes";
import { buildServerConfig } from "../utils/config";
import { getServerInternalPlugins } from "../utils/getServerInternalPlugins";
var dev = function() {
  var _ref = _async_to_generator(function(api, options) {
    var devServerOptions, _normalizedConfig_source, _normalizedConfig_tools, normalizedConfig, appContext, hookRunners, appDirectory, distDirectory, port, apiOnly, serverConfigFile, metaName, serverRoutes, serverInternalPlugins, serverOptions, _normalizedConfig_dev, app, host, server;
    var _arguments = arguments;
    return _ts_generator(this, function(_state) {
      switch (_state.label) {
        case 0:
          devServerOptions = _arguments.length > 2 && _arguments[2] !== void 0 ? _arguments[2] : {};
          if (options.analyze) {
            process.env.BUNDLE_ANALYZE = "true";
          }
          normalizedConfig = api.useResolvedConfigContext();
          appContext = api.useAppContext();
          hookRunners = api.useHookRunners();
          return [
            4,
            registerCompiler(appContext.appDirectory, appContext.distDirectory, normalizedConfig === null || normalizedConfig === void 0 ? void 0 : (_normalizedConfig_source = normalizedConfig.source) === null || _normalizedConfig_source === void 0 ? void 0 : _normalizedConfig_source.alias)
          ];
        case 1:
          _state.sent();
          normalizedConfig = _object_spread_props(_object_spread({}, normalizedConfig), {
            cliOptions: options
          });
          ResolvedConfigContext.set(normalizedConfig);
          appDirectory = appContext.appDirectory, distDirectory = appContext.distDirectory, port = appContext.port, apiOnly = appContext.apiOnly, serverConfigFile = appContext.serverConfigFile, metaName = appContext.metaName, serverRoutes = appContext.serverRoutes;
          return [
            4,
            buildServerConfig({
              appDirectory,
              distDirectory,
              configFile: serverConfigFile,
              watch: true
            })
          ];
        case 2:
          _state.sent();
          return [
            4,
            hookRunners.beforeDev()
          ];
        case 3:
          _state.sent();
          if (!appContext.builder && !apiOnly) {
            throw new Error("Expect the Builder to have been initialized, But the appContext.builder received `undefined`");
          }
          return [
            4,
            generateRoutes(appContext)
          ];
        case 4:
          _state.sent();
          return [
            4,
            getServerInternalPlugins(api)
          ];
        case 5:
          serverInternalPlugins = _state.sent();
          serverOptions = _object_spread({
            metaName,
            dev: _object_spread({
              port,
              https: normalizedConfig.dev.https,
              host: normalizedConfig.dev.host
            }, (_normalizedConfig_tools = normalizedConfig.tools) === null || _normalizedConfig_tools === void 0 ? void 0 : _normalizedConfig_tools.devServer),
            appContext: {
              appDirectory,
              apiDirectory: appContext.apiDirectory,
              lambdaDirectory: appContext.lambdaDirectory,
              sharedDirectory: appContext.sharedDirectory
            },
            routes: serverRoutes,
            pwd: appDirectory,
            config: normalizedConfig,
            serverConfigFile,
            internalPlugins: serverInternalPlugins
          }, devServerOptions);
          if (!apiOnly)
            return [
              3,
              7
            ];
          return [
            4,
            createDevServer(serverOptions, initProdMiddlewares)
          ];
        case 6:
          app = _state.sent();
          host = ((_normalizedConfig_dev = normalizedConfig.dev) === null || _normalizedConfig_dev === void 0 ? void 0 : _normalizedConfig_dev.host) || DEFAULT_DEV_HOST;
          app.listen({
            port,
            host
          }, function() {
            printInstructions(hookRunners, appContext, normalizedConfig);
          });
          return [
            3,
            9
          ];
        case 7:
          return [
            4,
            appContext.builder.startDevServer({
              serverOptions,
              initProdMiddlewares
            })
          ];
        case 8:
          server = _state.sent().server;
          setServer(server);
          _state.label = 9;
        case 9:
          return [
            2
          ];
      }
    });
  });
  return function dev2(api, options) {
    return _ref.apply(this, arguments);
  };
}();
export {
  dev
};
