import { _ as _async_to_generator } from "@swc/helpers/_/_async_to_generator";
import { _ as _object_spread } from "@swc/helpers/_/_object_spread";
import { _ as _object_spread_props } from "@swc/helpers/_/_object_spread_props";
import { _ as _ts_generator } from "@swc/helpers/_/_ts_generator";
import path from "path";
import { lintPlugin } from "@modern-js/plugin-lint";
import { cleanRequireCache, emptyDir, getCommand, getArgv, fs, NESTED_ROUTE_SPEC_FILE, newAction, upgradeAction } from "@modern-js/utils";
import { castArray } from "@modern-js/utils/lodash";
import { getLocaleLanguage } from "@modern-js/plugin-i18n/language-detector";
import analyzePlugin from "./analyze";
import initializePlugin from "./initialize";
import { hooks } from "./hooks";
import { i18n, localeKeys } from "./locale";
import serverBuildPlugin from "./plugins/serverBuild";
import deployPlugin from "./plugins/deploy";
import { restart } from "./utils/restart";
import { generateWatchFiles } from "./utils/generateWatchFiles";
import { mergeConfig } from "@modern-js/core";
import { dev } from "./commands";
export * from "./defineConfig";
export * from "./types";
var devCommand = function() {
  var _ref = _async_to_generator(function(program, api) {
    var runner, devToolMetas, devProgram, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, meta, _iteratorNormalCompletion1, _didIteratorError1, _iteratorError1, _iterator1, _step1, subCmd;
    return _ts_generator(this, function(_state) {
      switch (_state.label) {
        case 0:
          runner = api.useHookRunners();
          return [
            4,
            runner.registerDev()
          ];
        case 1:
          devToolMetas = _state.sent();
          devProgram = program.command("dev").alias("start").usage("[options]").description(i18n.t(localeKeys.command.dev.describe)).option("-c --config <config>", i18n.t(localeKeys.command.shared.config)).option("-e --entry [entry...]", i18n.t(localeKeys.command.dev.entry)).option("--analyze", i18n.t(localeKeys.command.shared.analyze)).option("--api-only", i18n.t(localeKeys.command.dev.apiOnly)).option("--web-only", i18n.t(localeKeys.command.dev.webOnly)).action(function() {
            var _ref2 = _async_to_generator(function(options) {
              var dev2;
              return _ts_generator(this, function(_state2) {
                switch (_state2.label) {
                  case 0:
                    return [
                      4,
                      import("./commands/dev")
                    ];
                  case 1:
                    dev2 = _state2.sent().dev;
                    return [
                      4,
                      dev2(api, options)
                    ];
                  case 2:
                    _state2.sent();
                    return [
                      2
                    ];
                }
              });
            });
            return function(options) {
              return _ref2.apply(this, arguments);
            };
          }());
          _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = void 0;
          try {
            for (_iterator = devToolMetas[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              meta = _step.value;
              if (!meta.subCommands) {
                continue;
              }
              _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = void 0;
              try {
                for (_iterator1 = meta.subCommands[Symbol.iterator](); !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true) {
                  subCmd = _step1.value;
                  devProgram.command(subCmd).action(/* @__PURE__ */ _async_to_generator(function() {
                    var options, appDirectory, isTypescript;
                    var _arguments = arguments;
                    return _ts_generator(this, function(_state2) {
                      switch (_state2.label) {
                        case 0:
                          options = _arguments.length > 0 && _arguments[0] !== void 0 ? _arguments[0] : {};
                          appDirectory = api.useAppContext().appDirectory;
                          return [
                            4,
                            import("@modern-js/utils")
                          ];
                        case 1:
                          isTypescript = _state2.sent().isTypescript;
                          return [
                            4,
                            runner.beforeDevTask(meta)
                          ];
                        case 2:
                          _state2.sent();
                          return [
                            4,
                            meta.action(options, {
                              isTsProject: isTypescript(appDirectory)
                            })
                          ];
                        case 3:
                          _state2.sent();
                          return [
                            2
                          ];
                      }
                    });
                  }));
                }
              } catch (err) {
                _didIteratorError1 = true;
                _iteratorError1 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                    _iterator1.return();
                  }
                } finally {
                  if (_didIteratorError1) {
                    throw _iteratorError1;
                  }
                }
              }
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }
          return [
            2
          ];
      }
    });
  });
  return function devCommand2(program, api) {
    return _ref.apply(this, arguments);
  };
}();
var buildCommand = function() {
  var _ref = _async_to_generator(function(program, api) {
    var runner, platformBuilders, buildProgram, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _loop, _iterator, _step;
    return _ts_generator(this, function(_state) {
      switch (_state.label) {
        case 0:
          runner = api.useHookRunners();
          return [
            4,
            runner.registerBuildPlatform()
          ];
        case 1:
          platformBuilders = _state.sent();
          buildProgram = program.command("build").usage("[options]").description(i18n.t(localeKeys.command.build.describe)).option("-c --config <config>", i18n.t(localeKeys.command.shared.config)).option("--analyze", i18n.t(localeKeys.command.shared.analyze)).action(function() {
            var _ref2 = _async_to_generator(function(options) {
              var build;
              return _ts_generator(this, function(_state2) {
                switch (_state2.label) {
                  case 0:
                    return [
                      4,
                      import("./commands/build")
                    ];
                  case 1:
                    build = _state2.sent().build;
                    return [
                      4,
                      build(api, options)
                    ];
                  case 2:
                    _state2.sent();
                    return [
                      2
                    ];
                }
              });
            });
            return function(options) {
              return _ref2.apply(this, arguments);
            };
          }());
          _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = void 0;
          try {
            _loop = function() {
              var platformBuilder = _step.value;
              var platforms = castArray(platformBuilder.platform);
              var _iteratorNormalCompletion2 = true, _didIteratorError2 = false, _iteratorError2 = void 0;
              try {
                var _loop2 = function() {
                  var platform = _step1.value;
                  buildProgram.command(platform).action(/* @__PURE__ */ _async_to_generator(function() {
                    var appDirectory, isTypescript;
                    return _ts_generator(this, function(_state2) {
                      switch (_state2.label) {
                        case 0:
                          appDirectory = api.useAppContext().appDirectory;
                          return [
                            4,
                            import("@modern-js/utils")
                          ];
                        case 1:
                          isTypescript = _state2.sent().isTypescript;
                          return [
                            4,
                            runner.beforeBuildPlatform(platformBuilders)
                          ];
                        case 2:
                          _state2.sent();
                          return [
                            4,
                            platformBuilder.build(platform, {
                              isTsProject: isTypescript(appDirectory)
                            })
                          ];
                        case 3:
                          _state2.sent();
                          return [
                            2
                          ];
                      }
                    });
                  }));
                };
                for (var _iterator2 = platforms[Symbol.iterator](), _step1; !(_iteratorNormalCompletion2 = (_step1 = _iterator2.next()).done); _iteratorNormalCompletion2 = true)
                  _loop2();
              } catch (err) {
                _didIteratorError2 = true;
                _iteratorError2 = err;
              } finally {
                try {
                  if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
                    _iterator2.return();
                  }
                } finally {
                  if (_didIteratorError2) {
                    throw _iteratorError2;
                  }
                }
              }
            };
            for (_iterator = platformBuilders[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true)
              _loop();
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return != null) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }
          return [
            2
          ];
      }
    });
  });
  return function buildCommand2(program, api) {
    return _ref.apply(this, arguments);
  };
}();
var appTools = function() {
  var options = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : {
    bundler: "webpack"
  };
  return {
    name: "@modern-js/app-tools",
    post: [
      "@modern-js/plugin-initialize",
      "@modern-js/plugin-analyze",
      "@modern-js/plugin-ssr",
      "@modern-js/plugin-document",
      "@modern-js/plugin-state",
      "@modern-js/plugin-router",
      "@modern-js/plugin-router-v5",
      "@modern-js/plugin-polyfill"
    ],
    registerHook: hooks,
    usePlugins: [
      initializePlugin({
        bundler: (options === null || options === void 0 ? void 0 : options.bundler) === "experimental-rspack" ? "rspack" : "webpack"
      }),
      analyzePlugin({
        bundler: (options === null || options === void 0 ? void 0 : options.bundler) === "experimental-rspack" ? "rspack" : "webpack"
      }),
      serverBuildPlugin(),
      lintPlugin(),
      deployPlugin()
    ],
    setup: function(api) {
      var appContext = api.useAppContext();
      api.setAppContext(_object_spread_props(_object_spread({}, appContext), {
        toolsType: "app-tools"
      }));
      var nestedRoutes = {};
      var locale = getLocaleLanguage();
      i18n.changeLanguage({
        locale
      });
      return {
        beforeConfig: function beforeConfig() {
          return _async_to_generator(function() {
            var _userConfig_output, userConfig, appContext2;
            return _ts_generator(this, function(_state) {
              userConfig = api.useConfigContext();
              appContext2 = api.useAppContext();
              if ((_userConfig_output = userConfig.output) === null || _userConfig_output === void 0 ? void 0 : _userConfig_output.tempDir) {
                api.setAppContext(_object_spread_props(_object_spread({}, appContext2), {
                  internalDirectory: path.resolve(appContext2.appDirectory, userConfig.output.tempDir)
                }));
              }
              return [
                2
              ];
            });
          })();
        },
        commands: function commands(param) {
          var program = param.program;
          return _async_to_generator(function() {
            return _ts_generator(this, function(_state) {
              switch (_state.label) {
                case 0:
                  return [
                    4,
                    devCommand(program, api)
                  ];
                case 1:
                  _state.sent();
                  return [
                    4,
                    buildCommand(program, api)
                  ];
                case 2:
                  _state.sent();
                  program.command("serve").usage("[options]").description(i18n.t(localeKeys.command.serve.describe)).option("--api-only", i18n.t(localeKeys.command.dev.apiOnly)).option("-c --config <config>", i18n.t(localeKeys.command.shared.config)).action(/* @__PURE__ */ _async_to_generator(function() {
                    var start;
                    return _ts_generator(this, function(_state2) {
                      switch (_state2.label) {
                        case 0:
                          return [
                            4,
                            import("./commands/serve")
                          ];
                        case 1:
                          start = _state2.sent().start;
                          return [
                            4,
                            start(api)
                          ];
                        case 2:
                          _state2.sent();
                          return [
                            2
                          ];
                      }
                    });
                  }));
                  program.command("deploy").usage("[options]").option("-c --config <config>", i18n.t(localeKeys.command.shared.config)).option("-s --skip-build", i18n.t(localeKeys.command.shared.skipBuild)).description(i18n.t(localeKeys.command.deploy.describe)).action(function() {
                    var _ref = _async_to_generator(function(options2) {
                      var build, deploy;
                      return _ts_generator(this, function(_state2) {
                        switch (_state2.label) {
                          case 0:
                            if (!!options2.skipBuild)
                              return [
                                3,
                                3
                              ];
                            return [
                              4,
                              import("./commands/build")
                            ];
                          case 1:
                            build = _state2.sent().build;
                            return [
                              4,
                              build(api)
                            ];
                          case 2:
                            _state2.sent();
                            _state2.label = 3;
                          case 3:
                            return [
                              4,
                              import("./commands/deploy")
                            ];
                          case 4:
                            deploy = _state2.sent().deploy;
                            return [
                              4,
                              deploy(api, options2)
                            ];
                          case 5:
                            _state2.sent();
                            process.exit(0);
                            return [
                              2
                            ];
                        }
                      });
                    });
                    return function(options2) {
                      return _ref.apply(this, arguments);
                    };
                  }());
                  program.command("new").usage("[options]").description(i18n.t(localeKeys.command.new.describe)).option("--config-file <configFile>", i18n.t(localeKeys.command.shared.config)).option("--lang <lang>", i18n.t(localeKeys.command.new.lang)).option("-c, --config <config>", i18n.t(localeKeys.command.new.config)).option("-d, --debug", i18n.t(localeKeys.command.new.debug), false).option("--dist-tag <tag>", i18n.t(localeKeys.command.new.distTag)).option("--registry", i18n.t(localeKeys.command.new.registry)).option("--no-need-install", i18n.t(localeKeys.command.shared.noNeedInstall)).action(function() {
                    var _ref = _async_to_generator(function(options2) {
                      return _ts_generator(this, function(_state2) {
                        switch (_state2.label) {
                          case 0:
                            return [
                              4,
                              newAction(_object_spread_props(_object_spread({}, options2), {
                                locale: options2.lang || locale
                              }), "mwa")
                            ];
                          case 1:
                            _state2.sent();
                            return [
                              2
                            ];
                        }
                      });
                    });
                    return function(options2) {
                      return _ref.apply(this, arguments);
                    };
                  }());
                  program.command("inspect").description("inspect the internal configs").option("--env <env>", i18n.t(localeKeys.command.inspect.env), "development").option("--output <output>", i18n.t(localeKeys.command.inspect.output), "/").option("--verbose", i18n.t(localeKeys.command.inspect.verbose)).option("-c --config <config>", i18n.t(localeKeys.command.shared.config)).action(function() {
                    var _ref = _async_to_generator(function(options2) {
                      var inspect;
                      return _ts_generator(this, function(_state2) {
                        switch (_state2.label) {
                          case 0:
                            return [
                              4,
                              import("./commands/inspect")
                            ];
                          case 1:
                            inspect = _state2.sent().inspect;
                            inspect(api, options2);
                            return [
                              2
                            ];
                        }
                      });
                    });
                    return function(options2) {
                      return _ref.apply(this, arguments);
                    };
                  }());
                  program.command("upgrade").allowUnknownOption().option("-h --help", "Show help").action(/* @__PURE__ */ _async_to_generator(function() {
                    return _ts_generator(this, function(_state2) {
                      switch (_state2.label) {
                        case 0:
                          return [
                            4,
                            upgradeAction()
                          ];
                        case 1:
                          _state2.sent();
                          return [
                            2
                          ];
                      }
                    });
                  }));
                  return [
                    2
                  ];
              }
            });
          })();
        },
        prepare: function prepare() {
          return _async_to_generator(function() {
            var command, isSkipBuild, resolvedConfig, appContext2;
            return _ts_generator(this, function(_state) {
              switch (_state.label) {
                case 0:
                  command = getCommand();
                  if (command === "deploy") {
                    isSkipBuild = [
                      "-s",
                      "--skip-build"
                    ].some(function(tag) {
                      return getArgv().includes(tag);
                    });
                    if (isSkipBuild) {
                      return [
                        2
                      ];
                    }
                  }
                  if (!(command === "dev" || command === "start" || command === "build" || command === "deploy"))
                    return [
                      3,
                      2
                    ];
                  resolvedConfig = api.useResolvedConfigContext();
                  if (!resolvedConfig.output.cleanDistPath)
                    return [
                      3,
                      2
                    ];
                  appContext2 = api.useAppContext();
                  return [
                    4,
                    emptyDir(appContext2.distDirectory)
                  ];
                case 1:
                  _state.sent();
                  _state.label = 2;
                case 2:
                  return [
                    2
                  ];
              }
            });
          })();
        },
        watchFiles: function watchFiles() {
          return _async_to_generator(function() {
            var appContext2, config;
            return _ts_generator(this, function(_state) {
              switch (_state.label) {
                case 0:
                  appContext2 = api.useAppContext();
                  config = api.useResolvedConfigContext();
                  return [
                    4,
                    generateWatchFiles(appContext2, config.source.configDir)
                  ];
                case 1:
                  return [
                    2,
                    _state.sent()
                  ];
              }
            });
          })();
        },
        fileChange: (
          // 这里会被 core/initWatcher 监听的文件变动触发，如果是 src 目录下的文件变动，则不做 restart
          function fileChange(e) {
            return _async_to_generator(function() {
              var filename, eventType, isPrivate, closeServer;
              return _ts_generator(this, function(_state) {
                switch (_state.label) {
                  case 0:
                    filename = e.filename, eventType = e.eventType, isPrivate = e.isPrivate;
                    if (!(!isPrivate && (eventType === "change" || eventType === "unlink")))
                      return [
                        3,
                        4
                      ];
                    return [
                      4,
                      import("./utils/createServer")
                    ];
                  case 1:
                    closeServer = _state.sent().closeServer;
                    return [
                      4,
                      closeServer()
                    ];
                  case 2:
                    _state.sent();
                    return [
                      4,
                      restart(api.useHookRunners(), filename)
                    ];
                  case 3:
                    _state.sent();
                    _state.label = 4;
                  case 4:
                    return [
                      2
                    ];
                }
              });
            })();
          }
        ),
        beforeRestart: function beforeRestart() {
          return _async_to_generator(function() {
            return _ts_generator(this, function(_state) {
              cleanRequireCache([
                require.resolve("./analyze")
              ]);
              return [
                2
              ];
            });
          })();
        },
        modifyFileSystemRoutes: function modifyFileSystemRoutes(param) {
          var entrypoint = param.entrypoint, routes = param.routes;
          return _async_to_generator(function() {
            return _ts_generator(this, function(_state) {
              nestedRoutes[entrypoint.entryName] = routes;
              return [
                2,
                {
                  entrypoint,
                  routes
                }
              ];
            });
          })();
        },
        beforeGenerateRoutes: function beforeGenerateRoutes(param) {
          var entrypoint = param.entrypoint, code = param.code;
          return _async_to_generator(function() {
            var distDirectory;
            return _ts_generator(this, function(_state) {
              switch (_state.label) {
                case 0:
                  distDirectory = api.useAppContext().distDirectory;
                  return [
                    4,
                    fs.outputJSON(path.resolve(distDirectory, NESTED_ROUTE_SPEC_FILE), nestedRoutes)
                  ];
                case 1:
                  _state.sent();
                  return [
                    2,
                    {
                      entrypoint,
                      code
                    }
                  ];
              }
            });
          })();
        }
      };
    }
  };
};
var src_default = appTools;
export {
  appTools,
  buildCommand,
  src_default as default,
  dev,
  devCommand,
  mergeConfig
};
