import { _ as _async_to_generator } from "@swc/helpers/_/_async_to_generator";
import { _ as _ts_generator } from "@swc/helpers/_/_ts_generator";
import path from "path";
import { fs as fse, getInternalPlugins } from "@modern-js/utils";
import { getProjectUsage } from "./utils";
import { handleDependencies } from "./dependencies";
function deploy_default() {
  return {
    name: "@modern-js/plugin-deploy",
    pre: [
      "@modern-js/plugin-bff",
      "@modern-js/plugin-server"
    ],
    setup: function(api) {
      return {
        beforeDeploy: function beforeDeploy() {
          return _async_to_generator(function() {
            var appContext, appDirectory, distDirectory, serverInternalPlugins, sharedDirectory, apiDirectory, lambdaDirectory, metaName, configContext, outputDirectory, bff, config, plugins, serverAppContext, code, deployTarget, genNodeEntry, genNetlifyEntry, _getProjectUsage, useSSR, useAPI, useWebServer, entryFilePath;
            return _ts_generator(this, function(_state) {
              switch (_state.label) {
                case 0:
                  appContext = api.useAppContext();
                  appDirectory = appContext.appDirectory, distDirectory = appContext.distDirectory, serverInternalPlugins = appContext.serverInternalPlugins, sharedDirectory = appContext.sharedDirectory, apiDirectory = appContext.apiDirectory, lambdaDirectory = appContext.lambdaDirectory, metaName = appContext.metaName;
                  configContext = api.useResolvedConfigContext();
                  outputDirectory = path.join(appDirectory, ".output");
                  return [
                    4,
                    fse.remove(outputDirectory)
                  ];
                case 1:
                  _state.sent();
                  return [
                    4,
                    fse.copy(distDirectory, outputDirectory, {
                      filter: function(src) {
                        var distStaticDirectory = path.join(distDirectory, "static");
                        return !src.includes(distStaticDirectory);
                      }
                    })
                  ];
                case 2:
                  _state.sent();
                  bff = configContext.bff;
                  config = {
                    output: {
                      path: "."
                    },
                    bff
                  };
                  plugins = getInternalPlugins(appDirectory, serverInternalPlugins);
                  serverAppContext = {
                    sharedDirectory: 'path.join(__dirname, "'.concat(path.relative(appDirectory, sharedDirectory), '")'),
                    apiDirectory: 'path.join(__dirname, "'.concat(path.relative(appDirectory, apiDirectory), '")'),
                    lambdaDirectory: 'path.join(__dirname, "'.concat(path.relative(appDirectory, lambdaDirectory), '")'),
                    metaName
                  };
                  code = "";
                  deployTarget = process.env.MODERNJS_DEPLOY || "node";
                  console.log("deployTarget111111111", deployTarget);
                  switch (deployTarget) {
                    case "node":
                      return [
                        3,
                        3
                      ];
                    case "netlify":
                      return [
                        3,
                        5
                      ];
                  }
                  return [
                    3,
                    7
                  ];
                case 3:
                  return [
                    4,
                    import("./entrys/node")
                  ];
                case 4:
                  genNodeEntry = _state.sent().genNodeEntry;
                  code = genNodeEntry({
                    plugins,
                    config,
                    appContext: serverAppContext
                  });
                  return [
                    3,
                    8
                  ];
                case 5:
                  return [
                    4,
                    import("./entrys/netlify")
                  ];
                case 6:
                  genNetlifyEntry = _state.sent().genNetlifyEntry;
                  code = genNetlifyEntry({
                    plugins,
                    config,
                    appContext: serverAppContext
                  });
                  return [
                    3,
                    8
                  ];
                case 7:
                  {
                    code = 'throw new Error("unknown deploy target, MODERNJS_DEPLOY should be set");';
                  }
                  _state.label = 8;
                case 8:
                  _getProjectUsage = getProjectUsage(appDirectory, outputDirectory), useSSR = _getProjectUsage.useSSR, useAPI = _getProjectUsage.useAPI, useWebServer = _getProjectUsage.useWebServer;
                  entryFilePath = path.join(outputDirectory, "index.js");
                  if (!(useSSR || useAPI || useWebServer))
                    return [
                      3,
                      10
                    ];
                  return [
                    4,
                    fse.writeFile(entryFilePath, code)
                  ];
                case 9:
                  _state.sent();
                  _state.label = 10;
                case 10:
                  return [
                    4,
                    handleDependencies(appDirectory, outputDirectory, [
                      "@modern-js/prod-server"
                    ])
                  ];
                case 11:
                  _state.sent();
                  return [
                    2
                  ];
              }
            });
          })();
        }
      };
    }
  };
}
;
export {
  deploy_default as default
};
