import { _ as _async_to_generator } from "@swc/helpers/_/_async_to_generator";
import { _ as _define_property } from "@swc/helpers/_/_define_property";
import { _ as _object_spread } from "@swc/helpers/_/_object_spread";
import { _ as _object_spread_props } from "@swc/helpers/_/_object_spread_props";
import { _ as _ts_generator } from "@swc/helpers/_/_ts_generator";
import path from "node:path";
import { fs, getAliasConfig, readTsConfigByFile } from "@modern-js/utils";
var registerCompiler = function() {
  var _ref = _async_to_generator(function() {
    var appDir, distDir, alias, TS_CONFIG_FILENAME, tsconfigPath, isTsProject, aliasConfig, _aliasConfig_paths, paths, _aliasConfig_absoluteBaseUrl, absoluteBaseUrl, tsPaths, tsConfig, tsNode, tsNodeOptions, error, esbuildRegister, tsConfigPaths, loaderRes;
    var _arguments = arguments;
    return _ts_generator(this, function(_state) {
      switch (_state.label) {
        case 0:
          appDir = _arguments.length > 0 && _arguments[0] !== void 0 ? _arguments[0] : process.cwd(), distDir = _arguments.length > 1 ? _arguments[1] : void 0, alias = _arguments.length > 2 ? _arguments[2] : void 0;
          TS_CONFIG_FILENAME = "tsconfig.json";
          tsconfigPath = path.resolve(appDir, TS_CONFIG_FILENAME);
          return [
            4,
            fs.pathExists(tsconfigPath)
          ];
        case 1:
          isTsProject = _state.sent();
          aliasConfig = getAliasConfig(alias, {
            appDirectory: appDir,
            tsconfigPath
          });
          _aliasConfig_paths = aliasConfig.paths, paths = _aliasConfig_paths === void 0 ? {} : _aliasConfig_paths, _aliasConfig_absoluteBaseUrl = aliasConfig.absoluteBaseUrl, absoluteBaseUrl = _aliasConfig_absoluteBaseUrl === void 0 ? "./" : _aliasConfig_absoluteBaseUrl;
          tsPaths = Object.keys(paths).reduce(function(o, key) {
            var tsPath = paths[key];
            if (typeof tsPath === "string" && path.isAbsolute(tsPath)) {
              tsPath = path.relative(absoluteBaseUrl, tsPath);
            }
            if (typeof tsPath === "string") {
              tsPath = [
                tsPath
              ];
            }
            return _object_spread_props(_object_spread({}, o), _define_property({}, "".concat(key), tsPath));
          }, {});
          tsConfig = {};
          if (isTsProject) {
            tsConfig = readTsConfigByFile(tsconfigPath);
          }
          _state.label = 2;
        case 2:
          _state.trys.push([
            2,
            4,
            ,
            6
          ]);
          return [
            4,
            import("ts-node")
          ];
        case 3:
          tsNode = _state.sent();
          tsNodeOptions = tsConfig["ts-node"];
          if (isTsProject) {
            tsNode.register(_object_spread({
              project: tsconfigPath,
              scope: true,
              // for env.d.ts, https://www.npmjs.com/package/ts-node#missing-types
              files: true,
              transpileOnly: true,
              ignore: [
                "(?:^|/)node_modules/",
                "(?:^|/)".concat(distDir, "/")
              ]
            }, tsNodeOptions));
          }
          return [
            3,
            6
          ];
        case 4:
          error = _state.sent();
          return [
            4,
            import("esbuild-register/dist/node")
          ];
        case 5:
          esbuildRegister = _state.sent();
          esbuildRegister.register({
            tsconfigRaw: isTsProject ? tsConfig : void 0,
            hookIgnoreNodeModules: true,
            hookMatcher: function(fileName) {
              return !fileName.startsWith(distDir);
            }
          });
          return [
            3,
            6
          ];
        case 6:
          return [
            4,
            import("@modern-js/utils/tsconfig-paths")
          ];
        case 7:
          tsConfigPaths = _state.sent();
          return [
            4,
            fs.pathExists(appDir)
          ];
        case 8:
          if (_state.sent()) {
            loaderRes = tsConfigPaths.loadConfig(appDir);
            if (loaderRes.resultType === "success") {
              tsConfigPaths.register({
                baseUrl: absoluteBaseUrl || "./",
                paths: tsPaths
              });
            }
          }
          return [
            2
          ];
      }
    });
  });
  return function registerCompiler2() {
    return _ref.apply(this, arguments);
  };
}();
export {
  registerCompiler
};
