import { IAppContext, PluginAPI } from '@modern-js/core';
import type { Entrypoint } from '@modern-js/types';
import { RspackConfig, WebpackConfig } from '@rsbuild/shared';
import { AppNormalizedConfig, AppTools, ImportStatement } from '../types';
export declare const createImportStatements: (statements: ImportStatement[]) => string;
export declare const generateCode: (appContext: IAppContext, config: AppNormalizedConfig<'shared'>, entrypoints: Entrypoint[], api: PluginAPI<AppTools<'shared'>>) => Promise<{
    importsStatemets: Map<string, ImportStatement[]>;
}>;
export declare const generateIndexCode: ({ appContext, api, entrypoints, config, importsStatemets, bundlerConfigs, }: {
    appContext: IAppContext;
    api: PluginAPI<AppTools<'shared'>>;
    entrypoints: Entrypoint[];
    config: AppNormalizedConfig<'shared'>;
    importsStatemets: Map<string, ImportStatement[]>;
    bundlerConfigs?: RspackConfig[] | WebpackConfig[] | undefined;
}) => Promise<void>;
