import type { Entrypoint, NestedRouteForCli, PageRoute, RouteLegacy, SSRMode } from '@modern-js/types';
import type { AppNormalizedConfig, IAppContext, RuntimePlugin } from '../types';
export declare const index: ({ mountId, imports, renderFunction, exportStatement, }: {
    mountId: string;
    imports: string;
    exportStatement: string;
    renderFunction: string;
}) => string;
export declare const renderFunction: ({ plugins, customBootstrap, fileSystemRoutes, }: {
    plugins: RuntimePlugin[];
    customBootstrap?: string | false | undefined;
    fileSystemRoutes: Entrypoint['fileSystemRoutes'];
}) => string;
export declare const html: (partials: {
    top: string[];
    head: string[];
    body: string[];
}) => string;
export declare const routesForServer: ({ routes, }: {
    routes: (NestedRouteForCli | PageRoute)[];
}) => string;
export declare const fileSystemRoutes: ({ routes, ssrMode, nestedRoutesEntry, entryName, internalDirectory, splitRouteChunks, }: {
    routes: RouteLegacy[] | (NestedRouteForCli | PageRoute)[];
    ssrMode?: SSRMode | undefined;
    nestedRoutesEntry?: string | undefined;
    entryName: string;
    internalDirectory: string;
    splitRouteChunks?: boolean | undefined;
}) => Promise<string>;
export declare function ssrLoaderCombinedModule(entrypoints: Entrypoint[], entrypoint: Entrypoint, config: AppNormalizedConfig<'shared'>, appContext: IAppContext): string | null;
