import { Command } from '@modern-js/utils';
import { CliPlugin, PluginAPI } from '@modern-js/core';
import { AppTools } from './types';
export { mergeConfig } from '@modern-js/core';
export { dev } from './commands';
export * from './defineConfig';
export * from './types';
export type { RuntimeUserConfig } from './types/config';
export declare const devCommand: (program: Command, api: PluginAPI<AppTools<'shared'>>) => Promise<void>;
export declare const buildCommand: (program: Command, api: PluginAPI<AppTools<'shared'>>) => Promise<void>;
export type AppToolsOptions = {
    /**
     * Specify which bundler to use for the build.
     * @default `webpack`
     * */
    bundler?: 'experimental-rspack' | 'webpack';
};
/**
 * The core package of the framework, providing CLI commands, build capabilities, configuration parsing and more.
 */
export declare const appTools: (options?: AppToolsOptions) => CliPlugin<AppTools<'shared'>>;
export default appTools;
