export interface MicroFrontend {
    /**
     * Specifies whether to enable the HTML entry.
     * When set to `true`, the current child application will be externalized for `react` and `react-dom`.
     * @default true
     */
    enableHtmlEntry?: boolean;
    /**
     * Specifies whether to use the external base library.
     * @default false
     */
    externalBasicLibrary?: boolean;
    moduleApp?: string;
}
export interface DeployUserConfig {
    /**
     * Used to configure micro-frontend sub-application information.
     * @default false
     */
    microFrontend?: boolean | MicroFrontend;
    worker?: {
        ssr?: boolean;
    };
}
